#include "ClockView.h"
ClockView::ClockView(BRect r,rgb_color clockcolour) : BView(r,NULL,B_FOLLOW_NONE,B_WILL_DRAW)
{
	UpdateTime();
	ClockColour = clockcolour;
}

void ClockView::UpdateTime()
{
	time_t the_time;
	struct tm *tm_ptr;
	(void) time(&the_time);
	tm_ptr = localtime(&the_time);

	hours = tm_ptr->tm_hour;
	minutes = tm_ptr->tm_min; 
	seconds = tm_ptr->tm_sec;
	_h = _m = _s = "";
	if(hours < 10)
	{
		_h << "0" << int(hours); 
	}
	else
	{
		_h << int(hours);
	}
	
	if(minutes < 10)
	{
		_m << "0" << int(minutes); 
	}
	else
	{
		_m << int(minutes);
	}
	
	if(seconds < 10)
	{
		_s << "0" << int(seconds); 
	}
	else
	{
		_s << int(seconds);
	}
	
	Invalidate();
}
bool ClockView::IsFinished()
{
	UpdateTime();
	return (hours == thours && minutes == tminutes && seconds == tseconds);
}

void ClockView::SetClockTarget(int h, int m, int s)
{
	thours = h;
	tminutes = m;
	tseconds = s;
}

void ClockView::SetClockViewClr(rgb_color update)
{
	ClockColour = update;
	Invalidate();
}
void ClockView::Draw(BRect updateRect)
{
	//UpdateTime();
	BFont font(be_bold_font);
	font.SetSize(26.0);
	SetFont(&font);
	SetHighColor(ClockColour);
	BString time;
	time << _h << ":" << _m  << ":"<< _s;
	MovePenTo(4,30);
	DrawString(time.String());
	
}