#include "CountDown.h"
CountDown::CountDown() : BWindow(BRect(50,50,200,220),"CountDown", B_TITLED_WINDOW,B_NOT_RESIZABLE| B_NOT_ZOOMABLE)
{
	//------LOAD SETTINGS--------//
    
	BPath path;
  	find_directory(B_USER_SETTINGS_DIRECTORY,&path);
  	path.Append("countdown_settings",true);
  	BFile file(path.Path(),B_READ_ONLY);
  	if(file.InitCheck() == B_OK)
  	{
		BMessage msg;
  		msg.Unflatten(&file);
		LoadSettings (&msg);
	}
	else
	{
		rgb_color temp = {255,0,0};
		TimeViewColour = temp;
		IsOnTop = false;
		AlarmSound.SetTo("/boot/beos/etc/sounds/BeBeep.wav");
		assert(AlarmSound.InitCheck() == B_OK);
		VolumeOfSound = 0.5;
		alarm_h=0;
		alarm_m=0;
		alarm_s=0;
		AlrtMessage = "What is BeOS?\nThere is no try; It just works.\nThe Jedi's OS.";
		ShowAlertMessage = false;
		IsExpanded = false;
		no_of_loops = 1;
		loop_enabled = false;
		UseMediaPlayer = false;
	}
	
	if(IsOnTop)
	{
		SetFeel(B_FLOATING_ALL_WINDOW_FEEL);//nice and on top of EVERYTHING :P
	}
	BRect r = Bounds();
	
	parent = new BView(Bounds(),"parent", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(parent);
	
	//--------BMENUBAR---------//
	BMenuBar* menubar = new BMenuBar(BRect(0,0,150,10),"menubar");
	
	BMenu* filemenu = new BMenu("File");
		
		MIGo = new BMenuItem("GO",new BMessage(CNTDWN_BUTTON_GO));
			filemenu->AddItem(MIGo);
		MICancel = new BMenuItem("Cancel",new BMessage(CNTDWN_BUTTON_CANCEL));
			filemenu->AddItem(MICancel);
			filemenu->AddSeparatorItem();
			MISettings = new BMenuItem("Settings...",new BMessage(CNTDWN_SETTINGS_PANEL),'S');
		filemenu->AddItem(MISettings);
		filemenu->AddSeparatorItem();
		filemenu->AddItem(new BMenuItem("About...",new BMessage(B_ABOUT_REQUESTED),'A'));
		filemenu->AddItem(new BMenuItem("Quit",new BMessage(B_QUIT_REQUESTED),'Q'));
	MIGo->SetEnabled(false);
	MICancel->SetEnabled(false);
	menubar->AddItem(filemenu);
	parent->AddChild(menubar);
	//-----BBOX------//
	//r.InsetBy(10,10);
	//r.top += 10;
	r = BRect(10,20,140,160);
	border = new BBox(r,NULL,B_FOLLOW_NONE);
	parent->AddChild(border);
	border->SetLabel("Timer");
	border->SetBorder(B_FANCY_BORDER);
	border->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	
	
	//---------BBOX for CLOCKVIEW-----//
	r.OffsetBy(140,0);
	clkborder = new BBox(r,NULL,B_FOLLOW_NONE);
	parent->AddChild(clkborder);
	clkborder->SetLabel("Alarm");
	clkborder->SetBorder(B_FANCY_BORDER);
	clkborder->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	//------TREEVIEW--------------//
	BRect trviewrect = border->Bounds();
	switcher = new TreeView(BRect(trviewrect.right - 20,15,trviewrect.right - 10,25),clkborder,140);
	if(!IsExpanded)
	clkborder->Hide();
	
	if(IsExpanded)
			switcher->SetTreeViewStatus(true);
		else
			switcher->SetTreeViewStatus(false);
		switcher->Invalidate();
	
	
	border->AddChild(switcher);
	switcher->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	//-------TIMEVIEW------------//
	TView = new TimeView(BRect(10,28,120,62),TimeViewColour);
	border->AddChild(TView);
	TView->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	TView->SetLowColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	//-------CLOCKVIEW-----------//
	ClkView = new ClockView(BRect(10,28,120,62),TimeViewColour);
	clkborder->AddChild(ClkView);
	ClkView->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	ClkView->SetLowColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	ClkView->SetClockTarget(alarm_h,alarm_m,alarm_s);
	BMessenger mymsnger(this);
	BMessage postme(DISPLAY_TIME);
	//sends lots of BMessages (STARTME) (1 every 1s) infinitely (-1) or until deleted
	timeupdate= new BMessageRunner(mymsnger,&postme,1000000,-1);
	/*SET CLOCK TARGET WITH THESE----*/
	//-----------HOURS---------//
	BRect timer2(12,70,52,90);
	clkhmenu = new BPopUpMenu("");
	for(int i=0;i<24;i++)
	{
		BString label;
		label << int(i);
		clkhmenu->AddItem(new BMenuItem(label.String(),new BMessage(CLOCKT_HOUR_CHANGED)));
	}
	
	clkhmenufield = new BMenuField(timer2,"hours",NULL,clkhmenu);
	
	clkborder->AddChild(clkhmenufield);
	clkhmenu->ItemAt(alarm_h)->SetMarked(true);
	
	//---------MINUTES------------//
	timer2.OffsetBy(40,0);
	clkmmenu = new BPopUpMenu("");
	for(int i=0;i<=59;i++)
	{
		BString label;
		label << int(i);
		clkmmenu->AddItem(new BMenuItem(label.String(),new BMessage(CLOCKT_MIN_CHANGED)));
	}
	clkmmenufield = new BMenuField(timer2,"minutes",NULL,clkmmenu);
	
	clkborder->AddChild(clkmmenufield);
	clkmmenu->ItemAt(alarm_m)->SetMarked(true);
	//-----------SECONDS--------//
	timer2.OffsetBy(40,0);
	clksmenu = new BPopUpMenu("");
	for(int i=0;i<=59;i++)
	{
		BString label;
		label << int(i);
		clksmenu->AddItem(new BMenuItem(label.String(),new BMessage(CLOCKT_SEC_CHANGED)));
	}
	clksmenufield = new BMenuField(timer2,"seconds",NULL,clksmenu);
	
	clkborder->AddChild(clksmenufield);
	clksmenu->ItemAt(alarm_s)->SetMarked(true);
	
	BRect ibtnrect(12,100,37,120);
		inch = new BButton(ibtnrect,"inch","h+",new BMessage(INCR_HOUR));
		ibtnrect.OffsetBy(42,0);
		incm = new BButton(ibtnrect,"incm","m+",new BMessage(INCR_MIN));
		ibtnrect.OffsetBy(42,0);
		ibtnrect.right -=5;
		ibtnrect.left -=5;
		incs = new BButton(ibtnrect,"incs","s+",new BMessage(INCR_SEC));
	clkborder->AddChild(inch);
	clkborder->AddChild(incm);
	clkborder->AddChild(incs);	
//-----------------------------SET TIME INTERVAL WITH THESE
	
	
	//-----------HOURS---------//
	BRect timer(12,70,52,90);
	hmenu = new BPopUpMenu("");
	for(int i=0;i<24;i++)
	{
		BString label;
		label << int(i);
		hmenu->AddItem(new BMenuItem(label.String(),new BMessage(CNTDWN_HOUR_CHANGED)));
	}
	
	hmenufield = new BMenuField(timer,"hours",NULL,hmenu);
	
	border->AddChild(hmenufield);
	hmenu->ItemAt(0)->SetMarked(true);
	
	//---------MINUTES------------//
	timer.OffsetBy(40,0);
	mmenu = new BPopUpMenu("");
	for(int i=0;i<=59;i++)
	{
		BString label;
		label << int(i);
		mmenu->AddItem(new BMenuItem(label.String(),new BMessage(CNTDWN_MIN_CHANGED)));
	}
	mmenufield = new BMenuField(timer,"minutes",NULL,mmenu);
	
	border->AddChild(mmenufield);
	mmenu->ItemAt(0)->SetMarked(true);
	//-----------SECONDS--------//
	timer.OffsetBy(40,0);
	smenu = new BPopUpMenu("");
	for(int i=0;i<=59;i++)
	{
		BString label;
		label << int(i);
		smenu->AddItem(new BMenuItem(label.String(),new BMessage(CNTDWN_SEC_CHANGED)));
	}
	smenufield = new BMenuField(timer,"seconds",NULL,smenu);
	
	border->AddChild(smenufield);
	smenu->ItemAt(0)->SetMarked(true);
	//------BUTTONS------------//
	BRect buttons(10,100,60,120);
	
	GO = new BButton(buttons,"GO","GO",
	new BMessage(CNTDWN_BUTTON_GO));
	border->AddChild(GO);
	
	buttons.OffsetBy(59,0);
	
	Cancel = new BButton(buttons,"Cancel","Cancel",
	new BMessage(CNTDWN_BUTTON_CANCEL));
	border->AddChild(Cancel);
	
	GO->SetEnabled(false);
	Cancel->SetEnabled(false);
	GO->MakeDefault(true);

		
}
int32 CountDown::thread_func2 (BMessage *args)
{
	
	bool temp_cond;
	int32 temp_int;
	bool usemedia;
	if(args->FindBool("enabled",&temp_cond) == B_OK && 
	args->FindInt32("looptime",&temp_int) == B_OK &&
	args->FindBool("media",&usemedia) == B_OK)
	{
	if(temp_cond)
	{
		if(usemedia)
		{
			entry_ref ref;
			double vollywolly;
			if(args->FindRef("sound",&ref) == B_OK && args->FindDouble("volume",&vollywolly) == B_OK)
			{	
				BPath path(&ref);
				BString temp;
			
				temp << "/boot/beos/apps/MediaPlayer -closeWhenDone on -autoPlay on -hideWindow -volume "
				<< float(vollywolly)*2 << " " << path.Path();
				while(temp_int != 0)
				{
				
					system(temp.String());
					temp_int--;
				}
			}
		}
		
		else
		{
			while(temp_int != 0)
			{
				double vollywolly;
				entry_ref ref;
				BSound* mysound;
				BSoundPlayer player;
				BSoundPlayer::play_id id;
	
				if(args->FindRef("sound",&ref) == B_OK && args->FindDouble("volume",&vollywolly) == B_OK)
				{	
					mysound = new BSound(&ref);
					if(mysound->InitCheck() == B_OK)
					{
						player.Start();
						player.SetVolume(vollywolly*2);
						id = player.StartPlaying(mysound);
						mysound->ReleaseRef();
						player.WaitForSound(id);
					}
		
				}
				temp_int--;
			}
		
		}
	}
	else//play once
	{
		if(usemedia)
		{
			entry_ref ref;
			double vollywolly;
			if(args->FindRef("sound",&ref) == B_OK && args->FindDouble("volume",&vollywolly) == B_OK)
			{	
				BPath path(&ref);
				BString temp;
				temp << "/boot/beos/apps/MediaPlayer -closeWhenDone on -autoPlay on -hideWindow -volume "
				<< float(vollywolly)*2 << " " << path.Path();
				
				system(temp.String());
		
			}
		}
		else
		{
			double vollywolly;
			entry_ref ref;
			BSound* mysound;
			BSoundPlayer player;
			BSoundPlayer::play_id id;
	
			if(args->FindRef("sound",&ref) == B_OK && args->FindDouble("volume",&vollywolly) == B_OK)
			{	
				mysound = new BSound(&ref);
				if(mysound->InitCheck() == B_OK)
				{
					player.Start();
					player.SetVolume(vollywolly*2);
					id = player.StartPlaying(mysound);
					mysound->ReleaseRef();
					player.WaitForSound(id);
				}
			}
		}
	}
}
	
}
void CountDown::LoadSettings(BMessage* msg)
{
	BRect frame;
	if (msg->FindRect("windowframe",&frame) == B_OK) 
	{
		MoveTo(frame.left,frame.top);
		ResizeTo(frame.right-frame.left,frame.bottom-frame.top);
	}
	bool temp;
	
	if(msg->FindBool("isontop",&temp) == B_OK)
	{
		IsOnTop = temp;
	}
	
	bool temp2;
	
	if(msg->FindBool("showalrt",&temp2) == B_OK)
	{
		ShowAlertMessage = temp2;
	}
	
	bool temp3;
	
	if(msg->FindBool("expanded",&temp3) == B_OK)
	{
		IsExpanded = temp3;
		
		
	}
	bool temp4;
	
	if(msg->FindBool("isloop",&temp4) == B_OK)
	{
		loop_enabled = temp4;
	}
	
	bool temp5;
		if(msg->FindBool("media",&temp5) == B_OK)
	{
		UseMediaPlayer = temp5;
	}
	
	
	//msg.AddBool("media",UseMediaPlayer);
	
	
	int16 A[3];//red, green, blue;
	bool check=true;
	for(int i=0;i<3;i++)
	{	
		if((msg->FindInt16("tvcolour",i,&A[i])) != B_OK)
			check = false;
	}
	if(check)
	{
		TimeViewColour.red = A[0];
		TimeViewColour.green = A[1];
		TimeViewColour.blue = A[2];
	}
	
	BEntry myentry;
	entry_ref ref;
	if(msg->FindRef("sound",&ref) == B_OK)
	{
		myentry.SetTo(&ref);
		if(myentry.InitCheck() == B_OK)
			AlarmSound = myentry;
	}
	
	double vol;
	if(msg->FindDouble("volume",&vol) == B_OK)
	{
		VolumeOfSound = vol;
	}
	
	int32 t1,t2,t3;
	if(msg->FindInt32("alarm_t",0,&t1) == B_OK && 
	msg->FindInt32("alarm_t",1,&t2) == B_OK && 
	msg->FindInt32("alarm_t",2,&t3) == B_OK)
	{
		alarm_h=t1;
		alarm_m=t2;
		alarm_s=t3;
	}
	
	const char* temps;
	if(msg->FindString("alrtstr",&temps) == B_OK)
	{
		AlrtMessage = temps;
	}
	
	int32 mytemp;
	if(msg->FindInt32("loop",&mytemp) == B_OK)
	{
		no_of_loops = mytemp;
	}
			
}
void CountDown::SaveSettings()
{
	BMessage msg;
	
	msg.AddRect("windowframe",Frame());
	msg.AddInt16("tvcolour",TimeViewColour.red);
	msg.AddInt16("tvcolour",TimeViewColour.green);
	msg.AddInt16("tvcolour",TimeViewColour.blue);
	msg.AddBool("isontop",IsOnTop);
	msg.AddBool("showalrt",ShowAlertMessage);
	msg.AddDouble("volume",VolumeOfSound);
	msg.AddBool("expanded",IsExpanded);
	msg.AddInt32("alarm_t",alarm_h);
	msg.AddInt32("alarm_t",alarm_m);
	msg.AddInt32("alarm_t",alarm_s);
	msg.AddString("alrtstr",AlrtMessage.String());
	msg.AddInt32("loop",no_of_loops);
	msg.AddBool("isloop",loop_enabled);
	msg.AddBool("media",UseMediaPlayer);
	
	entry_ref ref;
	if(AlarmSound.InitCheck() == B_OK) 
	{
		if(AlarmSound.GetRef(&ref) == B_OK) 
		{
			msg.AddRef("sound",&ref);
		}
	}
	
	BPath path;
    if (find_directory(B_USER_SETTINGS_DIRECTORY,&path) == B_OK)
    {
	    path.Append("countdown_settings",true);
    	BFile file(path.Path(),B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);
	    msg.Flatten(&file);
	}
}
void CountDown::PlayAlarm()
{
	
	entry_ref ref;
	if(AlarmSound.InitCheck() == B_OK) 
	{	
		if(AlarmSound.GetRef(&ref) == B_OK) 
		{
			BMessage* mymessage = new BMessage(CNTDWN_PLAY);
			mymessage->AddRef("sound",&ref);
			mymessage->AddDouble("volume",VolumeOfSound);
			mymessage->AddBool("enabled",loop_enabled);
			mymessage->AddBool("media",UseMediaPlayer);
			mymessage->AddInt32("looptime",no_of_loops);
			thread_id launchedThread2 = spawn_thread(thread_func2,"alarmplayer",
			B_NORMAL_PRIORITY,mymessage);
	
		if (launchedThread2 >= 0)
      	resume_thread(launchedThread2);
		}
	}
	if(ShowAlertMessage)
	{
	BAlert* ready = new BAlert("ready",AlrtMessage.String(),"BeOS!",NULL,NULL,
	B_WIDTH_AS_USUAL,B_EVEN_SPACING,B_IDEA_ALERT);
	ready->SetFeel(B_MODAL_ALL_WINDOW_FEEL);
	ready->Go();
	}
}
CountDown::~CountDown()
{
	SaveSettings();
}

void CountDown::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case CLOCKT_HOUR_CHANGED:
		case CLOCKT_MIN_CHANGED:
		case CLOCKT_SEC_CHANGED:
		
		alarm_h = atoi((clkhmenu->FindMarked())->Label());
		alarm_m = atoi((clkmmenu->FindMarked())->Label());
		alarm_s = atoi((clksmenu->FindMarked())->Label());
		ClkView->SetClockTarget(alarm_h,alarm_m,alarm_s);

		break;
		case HANDLE_USE_MEDIA_PLAYER:
		{
			bool temp;
			if(msg->FindBool("media",&temp) == B_OK)
			{
				UseMediaPlayer = temp;
			}
		}break;
		case HANDLE_LOOP_TIMES:
		{
			int32 temp;
			bool temp2;
			if(msg->FindInt32("loop",&temp) == B_OK &&
			msg->FindBool("isloop",&temp2) == B_OK )
			{
				no_of_loops = temp;
				loop_enabled = temp2;
			}
		
		}break;
		case INCR_HOUR:
		{
			
			alarm_h = atoi((clkhmenu->FindMarked())->Label());
			if(alarm_h != 23)
				clkhmenu->ItemAt(alarm_h + 1)->SetMarked(true);
			alarm_h = atoi((clkhmenu->FindMarked())->Label());
			alarm_m = atoi((clkmmenu->FindMarked())->Label());
			alarm_s = atoi((clksmenu->FindMarked())->Label());
			ClkView->SetClockTarget(alarm_h,alarm_m,alarm_s);
		}break;
		case INCR_MIN:
		{
			alarm_m = atoi((clkmmenu->FindMarked())->Label());
			if(alarm_m != 59)
				clkmmenu->ItemAt(alarm_m +1)->SetMarked(true);
			alarm_h = atoi((clkhmenu->FindMarked())->Label());
			alarm_m = atoi((clkmmenu->FindMarked())->Label());
			alarm_s = atoi((clksmenu->FindMarked())->Label());
			ClkView->SetClockTarget(alarm_h,alarm_m,alarm_s);
		}break;
		case INCR_SEC:
		{	
			alarm_s = atoi((clksmenu->FindMarked())->Label());
			if(alarm_s != 59)
				clksmenu->ItemAt(alarm_s + 1)->SetMarked(true);
			alarm_h = atoi((clkhmenu->FindMarked())->Label());
			alarm_m = atoi((clkmmenu->FindMarked())->Label());
			alarm_s = atoi((clksmenu->FindMarked())->Label());
			ClkView->SetClockTarget(alarm_h,alarm_m,alarm_s);
		}break;
		
		case CNTDWN_HOUR_CHANGED:
		{
			TView->SetHour(atoi((hmenu->FindMarked())->Label()));
			
				if(!GO->IsEnabled())
				{	GO->SetEnabled(true);
					MIGo->SetEnabled(true);
				}
		}break;
		
		case CNTDWN_MIN_CHANGED:
		{
				TView->SetMin(atoi((mmenu->FindMarked())->Label()));
				if(!GO->IsEnabled())
				{
					GO->SetEnabled(true);
					MIGo->SetEnabled(true);
				}
		}break;
		
		case CNTDWN_SEC_CHANGED:
		{
				TView->SetSec(atoi((smenu->FindMarked())->Label()));
				if(!GO->IsEnabled())
				{
					GO->SetEnabled(true);
					MIGo->SetEnabled(true);
				}
		}break;
		case CNTDWN_BUTTON_CANCEL:
		{	
			
			TView->SetHour(0);
			TView->SetMin(0);
			TView->SetSec(0);
			
			hmenu->ItemAt(0)->SetMarked(true);
			mmenu->ItemAt(0)->SetMarked(true);
			smenu->ItemAt(0)->SetMarked(true);

			hmenu->SetEnabled(true);
			mmenu->SetEnabled(true);
			smenu->SetEnabled(true);
			
			if(GO->IsEnabled())
			{
				GO->SetEnabled(false);
				MIGo->SetEnabled(false);
			}
			Cancel->SetEnabled(false);
			MICancel->SetEnabled(false);
			delete update;
			
		
		}break;
		case START_COUNTDOWN:
		{
			if(!TView->IsFinished())
			{	
				TView->DecrementCounter();
				if(TView->IsFinished())
				{
					hmenu->ItemAt(0)->SetMarked(true);
					mmenu->ItemAt(0)->SetMarked(true);
					smenu->ItemAt(0)->SetMarked(true);
				
					hmenu->SetEnabled(true);
					mmenu->SetEnabled(true);
					smenu->SetEnabled(true);
					if(GO->IsEnabled())
					{
						GO->SetEnabled(false);
						MIGo->SetEnabled(false);
					}
					Cancel->SetEnabled(false);
					MICancel->SetEnabled(false);
					PlayAlarm();
					delete update;
				}
			}
		}break;
		
		case CNTDWN_BUTTON_GO:
		{
			
			if(!TView->IsFinished())
			{
				hmenu->SetEnabled(false);
				mmenu->SetEnabled(false);
				smenu->SetEnabled(false);
			
				GO->SetEnabled(false);
				MIGo->SetEnabled(false);
				Cancel->SetEnabled(true);
				MICancel->SetEnabled(true);
				BMessenger mymsnger(this);
				BMessage postme(START_COUNTDOWN);
				//sends lots of BMessages (STARTME) (1 every 1s) infinitely (-1) or until deleted
				update= new BMessageRunner(mymsnger,&postme,1000000,-1);
			}
		}break;
		
		case CLEANUP_MI:
		{
			MISettings->SetEnabled(true);
		}break;
		
		case TIMEVIEW_CLR_UPDATE:
		{
			int16 A[3];//red, green, blue;
			bool check=true;
			for(int i=0;i<3;i++)
			{	
				if((msg->FindInt16("colours",i,&A[i])) != B_OK)
				check = false;
			}
			if(check)
			{
				TimeViewColour.red = A[0];
				TimeViewColour.green = A[1];
				TimeViewColour.blue = A[2];
			}
			TView->SetTimeViewClr(TimeViewColour);
			ClkView->SetClockViewClr(TimeViewColour);
		
		}break;
		
		case CNTDWN_SET_ON_TOP:
		{
			bool temp;
			if(msg->FindBool("ontop",&temp) == B_OK)
				IsOnTop = temp;
		}break;
		
		case SET_ALRT_TEXT:
		{
		
		const char* temp;
			if(msg->FindString("alrtstring",&temp) == B_OK)
				AlrtMessage = temp;
		
		}break;
		
		case SET_SHOW_ALRT:
		{
			bool temp;
			if(msg->FindBool("show",&temp) == B_OK)
				ShowAlertMessage = temp;
		
		}break;
		
		case CNTDWN_SETTINGS_PANEL:
		{
			//BRect r = (be_app->WindowAt(0))->Frame();
			BPath path;
			AlarmSound.GetPath(&path);
			const char* pathString = path.Path();
		
			settingwndw = new SettingsWindow(BRect(100,100,471,410),
									      this,TimeViewColour,pathString,VolumeOfSound,
									      IsOnTop,AlrtMessage.String(),ShowAlertMessage,
									      loop_enabled,no_of_loops,UseMediaPlayer);
			settingwndw->Show();
			MISettings->SetEnabled(false);
		}break;

		case SOUND_SELECTION_RECEIVE:
		{
			
		BEntry myentry;
		entry_ref ref;
		if(msg->FindRef("sound",&ref) == B_OK)
		{
			myentry.SetTo(&ref);
			if(myentry.InitCheck() == B_OK)
				AlarmSound = myentry;
		}
		}break;
		
		case SET_SOUND_VOLUME:
		{
			double vol;
			if(msg->FindDouble("volume",&vol) == B_OK)
			{
			VolumeOfSound = vol;
			}
		}break;
		
		case DISPLAY_TIME:
		{
				ClkView->UpdateTime();
				if(ClkView->IsFinished())
					PlayAlarm();
		}break;
		case B_ABOUT_REQUESTED:
		{//this is cheap, should be in a BApplication
			AboutRequested();
		}break;
		
		default:
			BWindow::MessageReceived(msg);
	        break;
	}
}

void CountDown::ResizeHandler()
{
	if(switcher->TreeViewStatus())
	{	
		clkborder->Show();
		IsExpanded = true;
	}
	else
	{	
		clkborder->Hide();
		IsExpanded = false;
	}
	

}
bool CountDown :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}

void CountDown :: AboutRequested()
{
	BAlert* about = new BAlert("about",
	"CountDown 2.0\nby Brent Miszalski\nmisza@ihug.com.au",
	"Brent Miszalski's BeOS Portal","Sweet",NULL);
	int32 button_index = about->Go();
	const char* homepage = "http://homepages.ihug.com.au/~brentmor/";
	if(button_index == 0)
		be_roster->Launch("application/x-vnd.Be-NPOS",
		1,(char**) &homepage);
}
