#ifndef _COUNTDOWN_H
#define _COUNTDOWN_H

#include <iostream>
#include <Application.h>
#include <View.h>
#include <Window.h>
#include <Alert.h>
#include <Rect.h>
#include <MenuItem.h>
#include <MenuField.h>
#include <MenuBar.h>
#include <Menu.h>
#include <TextControl.h>
#include <PopUpMenu.h>
#include <Box.h>
#include <Button.h>
#include <MessageRunner.h>
#include <string>
#include <String.h>
#include <Beep.h>
#include <Roster.h>
#include <File.h>
#include <Path.h>
#include <FindDirectory.h>
#include <SoundPlayer.h>
#include <Sound.h>
#include <cassert>
#include <stdlib.h>
#include "TreeView.h"
#include "TimeView.h"
#include "Constants.h"
#include "SettingsWindow.h"
#include "ClockView.h"

class CountDown: public BWindow
{	//nothing much to see here :-)
	public:
		CountDown();
		~CountDown();
		virtual void MessageReceived(BMessage* msg);
		virtual bool QuitRequested();
		virtual void AboutRequested();
		void LoadSettings(BMessage *msg);
   		void SaveSettings();
   		void PlayAlarm();
   		void ResizeHandler();
	private:
		static int32 thread_func2 (BMessage *args);
		BView* parent;
		BBox* border;
		TreeView* switcher;
		
		BEntry AlarmSound;
		BTextControl* TCHour;
		BTextControl* TCMin;
		BTextControl* TCSec;
		
		BPopUpMenu* hmenu;
		BPopUpMenu* mmenu;
		BPopUpMenu* smenu;
		
		BMenuField* hmenufield;
		BMenuField* mmenufield;
		BMenuField* smenufield;
		
		BMenuItem* MIGo;
		BMenuItem* MICancel;
		BMenuItem* MISettings;
		
		BStringView* label;
		BButton* GO;
		BButton* Cancel;
		
		BButton* inch;
		BButton* incm;
		BButton* incs;
		TimeView* TView;
		BMessageRunner* update;
		
		ClockView* ClkView;
		BMessageRunner* timeupdate;
			
			BBox* clkborder;
			BPopUpMenu* clkhmenu;
			BPopUpMenu* clkmmenu;
			BPopUpMenu* clksmenu;
			BMenuField* clkhmenufield;
			BMenuField* clkmmenufield;
			BMenuField* clksmenufield;
		
		int32 alarm_h,alarm_m,alarm_s;
		
		rgb_color TimeViewColour;
		SettingsWindow* settingwndw;
		bool IsOnTop;
		bool ShowAlertMessage;
		double VolumeOfSound;
		
		bool IsExpanded;
		BString AlrtMessage;
		bool loop_enabled;
		int32 no_of_loops;
		bool UseMediaPlayer;
};
#endif