#include "SettingsWindow.h"

SettingsWindow::SettingsWindow(BRect r,BLooper* looper,rgb_color startclr,
const char* current_sound,double vollevel,bool ontop,
const char* ALERTSTR,bool ShowAlertMessage,bool loop_enabled,int32 loop_times,
bool usemediaplayer)

 : BWindow(r,"Settings",B_TITLED_WINDOW,B_NOT_RESIZABLE|B_NOT_ZOOMABLE|B_ASYNCHRONOUS_CONTROLS)
{
	UseMediaPlayer = usemediaplayer;
	loopy = looper;
	isloopy = loop_enabled;
	loopmetimes=loop_times;
	volume_level = vollevel;
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	AddChild(parent);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	
	BRect r = Bounds();
	r.left += 10;
	r.top += 10;
	r.right -= 10;
	r.bottom = 94;
	
	clrbbx = new BBox(r);
	parent->AddChild(clrbbx);
	
	clrbbx->SetLabel("Colour");
	clrbbx->SetBorder(B_FANCY_BORDER);
	clrbbx->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	
	r.OffsetBy(0,94);
	r.bottom+=30;
	//r.right -=130;
	sndbbx = new BBox(r);
	parent->AddChild(sndbbx);
	
	sndbbx->SetLabel("Sound");
	sndbbx->SetBorder(B_FANCY_BORDER);
	sndbbx->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	
	//---------------ADD COLOUR PREFS-------------//
	ctrlbox = new BColorControl(BPoint(10,20),B_CELLS_32x8,4.0,"ctrlbox",new BMessage(COLOURWINDOW_UPDATE_TIMER),true);
	clrbbx->AddChild(ctrlbox);
	
	clrbox = new BView(BRect(287,20,339,72),"clrbox",B_FOLLOW_ALL,B_WILL_DRAW);
	clrbbx->AddChild(clrbox);
	
	ctrlbox->SetValue(startclr);
	clrbox->SetViewColor(startclr);
	clrbox->Invalidate();
	
	
	
	
	
	
	//-----------------ADD SOUNDS PREFS------------------//
	
	//get all the current sounds on the system
	BDirectory usersounds("/boot/home/config/sounds");
	BDirectory systemsounds("/boot/beos/etc/sounds");
	BEntry entry;
	
	systemsounds.Rewind();
	while(systemsounds.GetNextEntry(&entry) == B_OK)
	{
		sounds.push_back(entry);
	}
	
	usersounds.Rewind();
	while(usersounds.GetNextEntry(&entry) == B_OK)
	{
		sounds.push_back(entry);
	}
	
	BPopSounds = new BPopUpMenu("Sounds");
	int size = sounds.size();
	for(int i=0;i<size;i++)
	{
		char name[B_FILE_NAME_LENGTH];
		sounds[i].GetName(name);
		BPopSounds->AddItem(new BMenuItem(name,new BMessage(SOUND_SELECTION_CHANGED)));
	}
	BString CurrentSound = current_sound;
	for(int i=0;i<size;i++)
	{
		BPath path;
		sounds[i].GetPath(&path);
		BString thisPath = path.Path();
		if(CurrentSound == thisPath)
			BPopSounds->ItemAt(i)->SetMarked(true);
	}
	
	BMenuField* soundpicker = new BMenuField(BRect(10,20,310,40),"soundpicker","Sound File:",BPopSounds);
	sndbbx->AddChild(soundpicker);
	soundpicker->SetDivider(55.0);
	BRect playbtn = sndbbx->Bounds();
	play = new BButton(BRect(playbtn.right-70,20,playbtn.right-10,40),"play","Play",
	new BMessage(SOUND_SELECTION_PLAY));
	sndbbx->AddChild(play);
	
	BString temp_label;
	temp_label << "Volume: " << int((volume_level*100)) << "%";
	volume = new BSlider(BRect(playbtn.right-120,60,playbtn.right-10,80),
	"volume",temp_label.String(),new BMessage(SOUND_VOLUME_SLIDER),
	0,4);
	const rgb_color beblue = {37,90,166};
	const rgb_color bered = {223,0,50};
	const rgb_color* usedfillcolor = &bered;
	volume->SetBarColor(beblue);
	volume->UseFillColor(true,usedfillcolor);
	volume->SetLimitLabels("0%", "100%");
	volume->SetHashMarks(B_HASH_MARKS_TOP);
	volume->SetHashMarkCount(5);
	volume->SetModificationMessage(new BMessage(SOUND_VOLUME_SLIDER));
	volume->SetValue(int((double(volume_level*10)/2.5)));
	sndbbx->AddChild(volume);
	
	if(UseMediaPlayer)
		volume->SetEnabled(false);
	cbump = new BCheckBox(BRect(10,50,200,60),"cbump",
	"Play Sounds Using MediaPlayer",new BMessage(DO_I_USE_MEDIA_PLAYER));
	sndbbx->AddChild(cbump);
	if(UseMediaPlayer)
		cbump->SetValue(B_CONTROL_ON);
	else
		cbump->SetValue(B_CONTROL_OFF);
	
	cbrepeat = new BCheckBox(BRect(10,70,200,80),"cbrepeat",
	"Loop Alert Sound", new BMessage(DO_I_SHOW_A_LOOP));
	sndbbx->AddChild(cbrepeat);
	
	loopselect = new BPopUpMenu("");
	
	for(int i=1;i<100;i++)
	{
		BString label;
		label << int(i);
		loopselect->AddItem(new BMenuItem(label.String(),new BMessage(CHANGED_LOOP_TIME)));
	}
	
	loopselect->ItemAt(loop_times-1)->SetMarked(true);
	BMenuField* loopfield = new BMenuField(BRect(10,90,180,100),"loopfield","Number Of Times To Loop:",loopselect);
	sndbbx->AddChild(loopfield);
	loopfield->SetDivider(130);
	
	
	if(isloopy)
	{
		cbrepeat->SetValue(B_CONTROL_ON);
		loopselect->SetEnabled(true);
	}
	else
	{
		cbrepeat->SetValue(B_CONTROL_OFF);
		loopselect->SetEnabled(false);
	}

	r.OffsetBy(0,110);
	r.top += 10;
	r.bottom -= 30;
	genbbx = new BBox(r);
	
	parent->AddChild(genbbx);
	
	genbbx->SetLabel("General");
	genbbx->SetBorder(B_FANCY_BORDER);
	genbbx->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	
	ShowAlert = new BCheckBox(BRect(10,20,150,40),"ShowAlert",
	"Show An Alert Message", new BMessage(DO_I_SHOW_AN_ALERT));
	genbbx->AddChild(ShowAlert);
	
	
	AlwaysOnTop = new BCheckBox(BRect(160,20,250,40),"AlwaysOnTop",
	"Always On Top",new BMessage(CNTDWN_ON_TOP));
	genbbx->AddChild(AlwaysOnTop);
	if(ontop)
		AlwaysOnTop->SetValue(B_CONTROL_ON);
	
	alrttext = new BTextControl(BRect(10,50,339,70),"alrttext",
	"Alarm Alert Text:",NULL,new BMessage(ALRT_TEXT_CHANGED));
	genbbx->AddChild(alrttext);
	alrttext->SetDivider(90);
	alrttext->SetText(ALERTSTR);
	
	if(ShowAlertMessage)
	{	
		ShowAlert->SetValue(B_CONTROL_ON);
	}
	else
	alrttext->SetEnabled(false);	
}
SettingsWindow::~SettingsWindow()
{
	BMessage mymsg(CLEANUP_MI);
	loopy->PostMessage(&mymsg);
}
void SettingsWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
	
		case DO_I_USE_MEDIA_PLAYER:
		{
			if(cbump->Value() == B_CONTROL_ON)
			{
				UseMediaPlayer = true;
				volume->SetEnabled(false);
				BMessage mymsg(HANDLE_USE_MEDIA_PLAYER);
				mymsg.AddBool("media",UseMediaPlayer);
				loopy->PostMessage(&mymsg);
			}
			else if(cbump->Value() == B_CONTROL_OFF)
			{
				UseMediaPlayer = false;
				volume->SetEnabled(true);
				BMessage mymsg(HANDLE_USE_MEDIA_PLAYER);
				mymsg.AddBool("media",UseMediaPlayer);
				loopy->PostMessage(&mymsg);
			}
		}break;
		case CHANGED_LOOP_TIME:
		{
			loopmetimes = atoi((loopselect->FindMarked())->Label());
			BMessage mymsg(HANDLE_LOOP_TIMES);
			mymsg.AddInt32("loop",loopmetimes);
			mymsg.AddBool("isloop",isloopy);
			loopy->PostMessage(&mymsg);
		}break;
		
		case DO_I_SHOW_A_LOOP:
		{
			if(cbrepeat->Value() == B_CONTROL_ON)
			{	
				loopselect->SetEnabled(true);
				isloopy = true;
				BMessage mymsg(HANDLE_LOOP_TIMES);
				mymsg.AddInt32("loop",loopmetimes);
				mymsg.AddBool("isloop",isloopy);
				loopy->PostMessage(&mymsg);
			}
			else if(cbrepeat->Value() == B_CONTROL_OFF)
			{	
				loopselect->SetEnabled(false);
				isloopy = false;
				BMessage mymsg(HANDLE_LOOP_TIMES);
				mymsg.AddInt32("loop",loopmetimes);
				mymsg.AddBool("isloop",isloopy);
				loopy->PostMessage(&mymsg);
			}	
		}break;
		case ALRT_TEXT_CHANGED:
		{
		BMessage mymsg(SET_ALRT_TEXT);
		mymsg.AddString("alrtstring",alrttext->Text());
		loopy->PostMessage(&mymsg);
		
		}break;
		
		case DO_I_SHOW_AN_ALERT:
		{
			if(ShowAlert->Value() == B_CONTROL_ON)
			{	
				bool temp = true;
				BMessage mymsg(SET_SHOW_ALRT);
				mymsg.AddBool("show",temp);
				loopy->PostMessage(&mymsg);
				alrttext->SetEnabled(true);
			}
			else if(ShowAlert->Value() == B_CONTROL_OFF)
			{
				bool temp = false;
				BMessage mymsg(SET_SHOW_ALRT);
				mymsg.AddBool("show",temp);
				loopy->PostMessage(&mymsg);
				alrttext->SetEnabled(false);
			}
		}break;
		
		case CNTDWN_ON_TOP:
		{
			if(AlwaysOnTop->Value() == B_CONTROL_ON)
			{	
				bool temp = true;
				BMessage mymsg(CNTDWN_SET_ON_TOP);
				mymsg.AddBool("ontop",temp);
				loopy->PostMessage(&mymsg);
				(be_app->WindowAt(0))->SetFeel(B_FLOATING_ALL_WINDOW_FEEL);
			}
			else if(AlwaysOnTop->Value() == B_CONTROL_OFF)
			{
				bool temp = false;
				BMessage mymsg(CNTDWN_SET_ON_TOP);
				mymsg.AddBool("ontop",temp);
				loopy->PostMessage(&mymsg);
				(be_app->WindowAt(0))->SetFeel(B_NORMAL_WINDOW_FEEL);
			}	
		}break;
		
		case COLOURWINDOW_UPDATE_TIMER:
		{
		rgb_color updated_colour = ctrlbox->ValueAsColor();
		clrbox->SetViewColor(updated_colour);
		clrbox->Invalidate();
		
		BMessage mymsg(TIMEVIEW_CLR_UPDATE);
		mymsg.AddInt16("colours",updated_colour.red);
		mymsg.AddInt16("colours",updated_colour.green);
		mymsg.AddInt16("colours",updated_colour.blue);
		loopy->PostMessage(&mymsg);

		}
		break;
		
		case SOUND_VOLUME_SLIDER:
	{
		double percentage = double(volume->Value()*2.5)/10;
		percentage *= 100;
		VolumeLabel << "Volume: " << (int)percentage << "%";
		volume->SetLabel(VolumeLabel.String());
		
		VolumeLabel = "";
		volume_level = double(percentage) / 100;
		
		BMessage postme(SET_SOUND_VOLUME);
		postme.AddDouble("volume",volume_level);
		loopy->PostMessage(&postme);
	}break;
	
	case SOUND_SELECTION_PLAY:
	{
	//want to pass: index, sounds
	entry_ref ref;
	BMessage postsound(SOUND_SELECTION_RECEIVE);
	BMessage *mymsg = new BMessage(SOUND_WINDOW_PLAY);
	
	index = BPopSounds->IndexOf(BPopSounds->FindMarked());
	//mymsg->AddInt32("index",index);
	mymsg->AddDouble("volume",volume_level);
	mymsg->AddBool("media",UseMediaPlayer);
	if(sounds[index].InitCheck() == B_OK) 
	{
		if(sounds[index].GetRef(&ref) == B_OK) 
		{
			mymsg->AddRef("sound",&ref);
			postsound.AddRef("sound",&ref);
		}
	}
	loopy->PostMessage(&postsound);
	thread_id launchedThread = spawn_thread(thread_func,"soundwindowplayer",
	B_NORMAL_PRIORITY,mymsg);
	
	if (launchedThread >= 0)
      resume_thread(launchedThread);
	}break;
	
	case SOUND_SELECTION_CHANGED:
	{
	int32 index = BPopSounds->IndexOf(BPopSounds->FindMarked());
	BMessage postsound(SOUND_SELECTION_RECEIVE);
	entry_ref ref;
	
	if(sounds[index].InitCheck() == B_OK) 
	{
		if(sounds[index].GetRef(&ref) == B_OK) 
		{
			postsound.AddRef("sound",&ref);
		}
	}
	
	loopy->PostMessage(&postsound);
	
	
	
	}break;
	
	default:
		BWindow::MessageReceived(msg);
	break;
	
	}
}//plays our test sound in a new thread :D
int32 SettingsWindow::thread_func (BMessage *args)
{
	double vollywolly;
	//int32 myindex;
	entry_ref ref;
	bool temp_bool;
	if(args->FindBool("media",&temp_bool) == B_OK)
	{
	if(temp_bool)
	{
		if(args->FindRef("sound",&ref) == B_OK && args->FindDouble("volume",&vollywolly) == B_OK)
		{	
			BPath path(&ref);
			BString temp;
			temp << "/boot/beos/apps/MediaPlayer -closeWhenDone on -autoPlay on -hideWindow -volume "
			<< float(vollywolly)*2 << " " << path.Path();
				
			system(temp.String());
		}
	}
	else
	{
		BSound* mysound;
		BSoundPlayer player;
		BSoundPlayer::play_id id;
	
		if(args->FindRef("sound",&ref) == B_OK && 
		//args->FindInt32("index",&myindex) == B_OK && 
		args->FindDouble("volume",&vollywolly) == B_OK)
		{
			mysound = new BSound(&ref);
			if(mysound->InitCheck() == B_OK)
			{
				player.Start();
				player.SetVolume(vollywolly*2);
				id = player.StartPlaying(mysound);
				mysound->ReleaseRef();
				player.WaitForSound(id);
			}
		}
	}
	}
}