#include "TimeView.h"
TimeView::TimeView(BRect r,rgb_color timecolour) : BView(r,NULL,B_FOLLOW_NONE,B_WILL_DRAW)
{
	
	hours = minutes = seconds = 0;
	_h = _m = _s = "00";
	TimeColour = timecolour;
}
bool TimeView::IsFinished()
{
	return (hours == 0 && minutes == 0 && seconds == 0);
}

void TimeView::DecrementCounter()
{
	if(seconds > 0)
	{	
		SetSec(seconds-1);
	}
	else if(seconds == 0)
	{
		SetSec(59);
		if(minutes > 0)
		SetMin(minutes-1);
		else
		{
		if(hours > 0)
		SetHour(hours-1);
		SetMin(59);
		SetSec(59);		
		}
	}
}
void TimeView::SetHour(int h)
{
	hours = h;
	_h = "";
	
	if(h < 10)
	{
		_h << "0" << int(h); 
	}
	else
	{
		_h << int(h);
	}
	Invalidate();
}

void TimeView::SetMin(int m)
{
	minutes = m;
	_m = "";
	
	if(m < 10)
	{
		_m << "0" << int(m); 
	}
	else
	{
		_m << int(m);
	}
	Invalidate();
}

void TimeView::SetSec(int s)
{
	seconds = s;
	_s = "";
	
	if(s < 10)
	{
		_s << "0" << int(s); 
	}
	else
	{
		_s << int(s);
	}
	Invalidate();
}
void TimeView::SetTimeViewClr(rgb_color update)
{
	TimeColour = update;
	Invalidate();
}
void TimeView::Draw(BRect updateRect)
{
	BFont font(be_bold_font);
	font.SetSize(26.0);
	SetFont(&font);
	SetHighColor(TimeColour);
	BString time;
	time << _h << ":" << _m  << ":"<< _s;
	MovePenTo(4,30);
	DrawString(time.String());
	
}